// ImageTextureP.C: ImageTexture nodes (private source).
// Automatically generated with nodegen 0.51 - do not edit.

#include "ImageTexture.H"
#include "xrmlP.H"

namespace xrml {
int ImageTexture::major_version(void) { return 0; }
int ImageTexture::minor_version(void) { return 5; }
bool ImageTexture::is_leaf_class(void) { return true; }

bool IsImageTexture(SFNode* node)
{
  return (dynamic_cast<ImageTexture*>(node) != 0);
}

bool ImageTexture::assign_url(const MFString& value)
{
  // TODO: value range check!
  url = value;
  status |= url_updated;
  timestamp = interface[0]->timestamp = world ? world->time : 0;
  return true;
}

static bool assign_ImageTexture_url(SFNode* node, const fieldValue& value)
{
  ImageTexture* ImageTexture_node = dynamic_cast<ImageTexture*>(node);
  if (!ImageTexture_node)
    Fatal(-1, "assign_ImageTexture_url", "called for a non-ImageTexture node");
  return ImageTexture_node->assign_url((const MFString&)value);
}

void ImageTexture::set_url(const MFString& val)
{
  MFString tmpval(val);
  fieldValue v(&tmpval);
  interface[0]->assign(this, v);
}

bool ImageTexture::assign_repeatS(const SFBool& value)
{
  // TODO: value range check!
  repeatS = value;
  status |= repeatS_updated;
  timestamp = interface[1]->timestamp = world ? world->time : 0;
  return true;
}

static bool assign_ImageTexture_repeatS(SFNode* node, const fieldValue& value)
{
  ImageTexture* ImageTexture_node = dynamic_cast<ImageTexture*>(node);
  if (!ImageTexture_node)
    Fatal(-1, "assign_ImageTexture_repeatS", "called for a non-ImageTexture node");
  return ImageTexture_node->assign_repeatS((const SFBool&)value);
}

bool ImageTexture::assign_repeatT(const SFBool& value)
{
  // TODO: value range check!
  repeatT = value;
  status |= repeatT_updated;
  timestamp = interface[2]->timestamp = world ? world->time : 0;
  return true;
}

static bool assign_ImageTexture_repeatT(SFNode* node, const fieldValue& value)
{
  ImageTexture* ImageTexture_node = dynamic_cast<ImageTexture*>(node);
  if (!ImageTexture_node)
    Fatal(-1, "assign_ImageTexture_repeatT", "called for a non-ImageTexture node");
  return ImageTexture_node->assign_repeatT((const SFBool&)value);
}

ImageTexture::ImageTexture()
{
  interfaceMember* the_interface[3] = {
    new exposedField("url", fieldValue(&url), assign_ImageTexture_url),
    new field("repeatS", fieldValue(&repeatS), assign_ImageTexture_repeatS),
    new field("repeatT", fieldValue(&repeatT), assign_ImageTexture_repeatT),
  };
  SFNode::construct(ImageTextureTypeId, 3, the_interface);

  url = MFString(0);
  repeatS = 1;
  repeatT = 1;
  
  PhBTexture::util_init();
  Texture::util_init();
  ImageTexture::util_init();
}

void ImageTexture::destruct(void)
{
  ImageTexture::util_destruct();
  Texture::util_destruct();
  PhBTexture::util_destruct();
  SFNode::destruct();
}

ImageTexture::~ImageTexture()
{
  destruct();
}

void ImageTexture::clone_here(const ImageTexture& src)
{
  SFNode::clone(src);
  
  interface[0]->value = fieldValue(&url);
  interface[1]->value = fieldValue(&repeatS);
  interface[2]->value = fieldValue(&repeatT);
  
  url = src.url;
  repeatS = src.repeatS;
  repeatT = src.repeatT;
  
  PhBTexture::util_clone(src);
  Texture::util_clone(src);
  ImageTexture::util_clone(src);
}

ImageTexture::ImageTexture(const ImageTexture& src)
{
  clone_here(src);
}

ImageTexture& ImageTexture::operator=(const ImageTexture& src)
{
  if (this != &src) {
    destruct();
    clone_here(src);
  }
  return *this;
}

SFNode* ImageTexture::instantiate(Proto *enclosing_proto)
{
  if (nameIndex>=0)
    // named node: return pointer to pre-made instance
    return enclosing_proto ? enclosing_proto->namedNodes[nameIndex] : this;
  
  ImageTexture* instance = new ImageTexture(*this);
  instance->instantiate_interface(enclosing_proto);
  return instance;
}

}  // namespace xrml
