// VisibilitySensorP.C: VisibilitySensor nodes (private source).
// Automatically generated with nodegen 0.5a - do not edit.

#include "VisibilitySensor.H"
#include "xrmlP.H"

namespace xrml {
int VisibilitySensor::major_version(void) { return 0; }
int VisibilitySensor::minor_version(void) { return 5; }
bool VisibilitySensor::is_leaf_class(void) { return true; }

bool IsVisibilitySensor(SFNode* node)
{
  return (dynamic_cast<VisibilitySensor*>(node) != 0);
}

bool VisibilitySensor::assign_center(const SFVec3f& value)
{
  // TODO: value range check!
  center = value;
  status |= center_updated;
  timestamp = interface[0]->timestamp = world ? world->time : 0;
  return true;
}

static bool assign_VisibilitySensor_center(SFNode* node, const fieldValue& value)
{
  VisibilitySensor* VisibilitySensor_node = dynamic_cast<VisibilitySensor*>(node);
  if (!VisibilitySensor_node)
    Fatal(-1, "assign_VisibilitySensor_center", "called for a non-VisibilitySensor node");
  return VisibilitySensor_node->assign_center((const SFVec3f&)value);
}

void VisibilitySensor::set_center(const SFVec3f& val)
{
  SFVec3f tmpval(val);
  fieldValue v(&tmpval);
  interface[0]->assign(this, v);
}

bool VisibilitySensor::assign_enabled(const SFBool& value)
{
  // TODO: value range check!
  enabled = value;
  status |= enabled_updated;
  timestamp = interface[1]->timestamp = world ? world->time : 0;
  return true;
}

static bool assign_VisibilitySensor_enabled(SFNode* node, const fieldValue& value)
{
  VisibilitySensor* VisibilitySensor_node = dynamic_cast<VisibilitySensor*>(node);
  if (!VisibilitySensor_node)
    Fatal(-1, "assign_VisibilitySensor_enabled", "called for a non-VisibilitySensor node");
  return VisibilitySensor_node->assign_enabled((const SFBool&)value);
}

void VisibilitySensor::set_enabled(const SFBool& val)
{
  SFBool tmpval(val);
  fieldValue v(&tmpval);
  interface[1]->assign(this, v);
}

bool VisibilitySensor::assign_size(const SFVec3f& value)
{
  // TODO: value range check!
  size = value;
  status |= size_updated;
  timestamp = interface[2]->timestamp = world ? world->time : 0;
  return true;
}

static bool assign_VisibilitySensor_size(SFNode* node, const fieldValue& value)
{
  VisibilitySensor* VisibilitySensor_node = dynamic_cast<VisibilitySensor*>(node);
  if (!VisibilitySensor_node)
    Fatal(-1, "assign_VisibilitySensor_size", "called for a non-VisibilitySensor node");
  return VisibilitySensor_node->assign_size((const SFVec3f&)value);
}

void VisibilitySensor::set_size(const SFVec3f& val)
{
  SFVec3f tmpval(val);
  fieldValue v(&tmpval);
  interface[2]->assign(this, v);
}

void VisibilitySensor::post_enterTime(void)
{
  interface[3]->post(this, interface[3]->value);
}

void VisibilitySensor::post_enterTime(const SFTime& val)
{
  enterTime = val;
  status |= enterTime_updated;
  post_enterTime();
}

void VisibilitySensor::post_exitTime(void)
{
  interface[4]->post(this, interface[4]->value);
}

void VisibilitySensor::post_exitTime(const SFTime& val)
{
  exitTime = val;
  status |= exitTime_updated;
  post_exitTime();
}

void VisibilitySensor::post_isActive(void)
{
  interface[5]->post(this, interface[5]->value);
}

void VisibilitySensor::post_isActive(const SFBool& val)
{
  isActive = val;
  status |= isActive_updated;
  post_isActive();
}

VisibilitySensor::VisibilitySensor()
{
  interfaceMember* the_interface[6] = {
    new exposedField("center", fieldValue(&center), assign_VisibilitySensor_center),
    new exposedField("enabled", fieldValue(&enabled), assign_VisibilitySensor_enabled),
    new exposedField("size", fieldValue(&size), assign_VisibilitySensor_size),
    new eventOut("enterTime", fieldValue(&enterTime)),
    new eventOut("exitTime", fieldValue(&exitTime)),
    new eventOut("isActive", fieldValue(&isActive)),
  };
  SFNode::construct(VisibilitySensorTypeId, 6, the_interface);

  center = SFVec3f(0,0,0);
  enabled = 1;
  size = SFVec3f(0,0,0);
  enterTime = 0;
  exitTime = 0;
  isActive = 0;
  
  Sensor::util_init();
  EnvironmentalSensor::util_init();
  Children::util_init();
  VisibilitySensor::util_init();
}

void VisibilitySensor::destruct(void)
{
  VisibilitySensor::util_destruct();
  EnvironmentalSensor::util_destruct();
  Sensor::util_destruct();
  Children::util_destruct();
  SFNode::destruct();
}

VisibilitySensor::~VisibilitySensor()
{
  destruct();
}

void VisibilitySensor::clone_here(const VisibilitySensor& src)
{
  SFNode::clone(src);
  
  interface[0]->value = fieldValue(&center);
  interface[1]->value = fieldValue(&enabled);
  interface[2]->value = fieldValue(&size);
  interface[3]->value = fieldValue(&enterTime);
  interface[4]->value = fieldValue(&exitTime);
  interface[5]->value = fieldValue(&isActive);
  
  center = src.center;
  enabled = src.enabled;
  size = src.size;
  enterTime = src.enterTime;
  exitTime = src.exitTime;
  isActive = src.isActive;
  
  Sensor::util_clone(src);
  EnvironmentalSensor::util_clone(src);
  Children::util_clone(src);
  VisibilitySensor::util_clone(src);
}

VisibilitySensor::VisibilitySensor(const VisibilitySensor& src)
{
  clone_here(src);
}

VisibilitySensor& VisibilitySensor::operator=(const VisibilitySensor& src)
{
  if (this != &src) {
    destruct();
    clone_here(src);
  }
  return *this;
}

SFNode* VisibilitySensor::instantiate(Proto *enclosing_proto)
{
  if (nameIndex>=0)
    // named node: return pointer to pre-made instance
    return enclosing_proto ? enclosing_proto->namedNodes[nameIndex] : this;
  
  VisibilitySensor* instance = new VisibilitySensor(*this);
  instance->instantiate_interface(enclosing_proto);
  return instance;
}

}  // namespace xrml
